#NoTrayIcon
#include <GUIConstants.au3>
#include <Constants.au3>
#include <String.au3>
Opt("GuiOnEventMode", 1)
Opt("TrayMenuMode", 1)
Opt("TrayOnEventMode", 1)
TraySetClick(16)

Global $AppName = StringRegExpReplace(@ScriptName, '\.[^.]*$', '')
Global $Main_Timer = -1
Global $Config_File = @ScriptDir & "\ReConnector.ini"

Global $Wait_Time_Read = IniRead($Config_File, "Prefs", "Wait Time", 0)
Global $Connect_Name_Read = IniRead($Config_File, "Prefs", "Connection Name", "ADSL")
Global $Login_Read = IniRead($Config_File, "Prefs", "Login", "")
Global $Password_Read = IniRead($Config_File, "Prefs", "Password", "")
$Password_Read = _StringEncrypt(0, $Password_Read, "AutoIt3", 2)


$Main_GUI = GUICreate(" ;)", 483, 310, -1, -1, -1, $WS_EX_TOOLWINDOW+$WS_EX_APPWINDOW+$WS_EX_TOPMOST)
GUISetOnEvent($GUI_EVENT_CLOSE, "MainEvents")

$Select_Label = GUICtrlCreateLabel("     ( ):", 24, 66, 343, 17)
$Wait_Input = GUICtrlCreateInput($Wait_Time_Read, 384, 64, 73, 21, $ES_AUTOHSCROLL+$ES_NUMBER, $WS_EX_CLIENTEDGE+$WS_EX_STATICEDGE)

$Connection_Name_Label = GUICtrlCreateLabel(" :", 24, 146, 99, 17)
$Login_Label = GUICtrlCreateLabel(":", 24, 178, 38, 17)
$Password_Label = GUICtrlCreateLabel("", 24, 210, 42, 17)

$Connect_Name_Input = GUICtrlCreateInput($Connect_Name_Read, 168, 144, 289, 21)
$Login_Input = GUICtrlCreateInput($Login_Read, 168, 176, 289, 21)
$Password_Input = GUICtrlCreateInput($Password_Read, 168, 208, 289, 21, $ES_PASSWORD+$ES_AUTOHSCROLL)

For $i = $Connect_Name_Input To $Password_Input
	GUICtrlSetStyle($i, -1, $WS_EX_CLIENTEDGE+$WS_EX_STATICEDGE)
Next

$Accept_Button = GUICtrlCreateButton("", 24, 264, 81, 20, 0)
GUICtrlSetOnEvent(-1, "MainEvents")
GUICtrlSetTip(-1, "       ")
$Exit_Button = GUICtrlCreateButton("", 128, 264, 81, 20, 0)
GUICtrlSetOnEvent(-1, "MainEvents")
GUICtrlSetTip(-1, " ")

$ReConnect_Now_TrayItem = TrayCreateItem(" ")
TrayItemSetOnEvent(-1, "TrayEvents")
$Exit_TrayItem = TrayCreateItem(" ")
TrayItemSetOnEvent(-1, "TrayEvents")
TraySetToolTip($AppName)

GUISetState(@SW_SHOW)

While 1
	If $Wait_Time_Read <> 0 And $Main_Timer <> -1 Then
		While 1
			$MSeconds_Time = $Wait_Time_Read * 60 * 1000
			$TimerDiff = Round(TimerDiff($Main_Timer))
			TraySetToolTip($AppName & @CRLF & _
				"   : " & _SecsToTime(($MSeconds_Time / 1000) - ($TimerDiff / 1000)))
			If $TimerDiff >= $MSeconds_Time Then ExitLoop
			Sleep(10)
		WEnd
		ReConnect()
		$Main_Timer = TimerInit()
	Else
		Sleep(100)
	EndIf
WEnd

Func MainEvents()
	Switch @GUI_CtrlId
		Case $GUI_EVENT_CLOSE, $Exit_Button
			Exit
		Case $Accept_Button
			Local $Read_Wait = Int(StringRegExpReplace(GUICtrlRead($Wait_Input), '[^0-9]', ''))
			
			If $Read_Wait = "" Or $Read_Wait <= 0 Then
				_MsgBox(48, "", "         .", $Main_GUI)
				GUICtrlSetState($Wait_Input, $GUI_FOCUS)
				Return
			Else
				GUICtrlSetData($Wait_Input, $Read_Wait)
			EndIf
			
			If GUICtrlRead($Connect_Name_Input) = "" Then
				_MsgBox(48, "", "  .", $Main_GUI)
				GUICtrlSetState($Connect_Name_Input, $GUI_FOCUS)
				Return
			EndIf
			
			If GUICtrlRead($Login_Input) = "" Then
				_MsgBox(48, "", " .", $Main_GUI)
				GUICtrlSetState($Login_Input, $GUI_FOCUS)
				Return
			EndIf
			
			If GUICtrlRead($Password_Input) = "" Then
				_MsgBox(48, "", " .", $Main_GUI)
				GUICtrlSetState($Password_Input, $GUI_FOCUS)
				Return
			EndIf
			
			TraySetState(1)
			GUISetState(@SW_HIDE)
			TraySetOnEvent($TRAY_EVENT_PRIMARYDOWN, "TrayEvents")
			SetData()
	EndSwitch
EndFunc

Func TrayEvents()
	Switch @TRAY_ID
		Case $TRAY_EVENT_PRIMARYDOWN
			TraySetState(2)
			GUISetState(@SW_SHOW)
		Case $ReConnect_Now_TrayItem
			ReConnect()
		Case $Exit_TrayItem
			Exit
	EndSwitch
EndFunc

Func ReConnect()
	ShellExecuteWait('Rasdial.exe', '"' & $Connect_Name_Read & '" /Disconnect', '', '', @SW_HIDE)
	Sleep(2000)
	ShellExecute('Rasdial.exe', '"' & $Connect_Name_Read & '" "' & $Login_Read & '" "' & $Password_Read & '"', '', '', @SW_HIDE)
EndFunc

Func SetData()
	$Main_Timer = TimerInit()
	$Wait_Time_Read = Int(StringRegExpReplace(GUICtrlRead($Wait_Input), '[^0-9]', ''))
	$Connect_Name_Read = GUICtrlRead($Connect_Name_Input)
	$Login_Read = GUICtrlRead($Login_Input)
	$Password_Read = GUICtrlRead($Password_Input)
	
	IniWrite($Config_File, "Prefs", "Wait Time", $Wait_Time_Read)
	IniWrite($Config_File, "Prefs", "Connection Name", $Connect_Name_Read)
	IniWrite($Config_File, "Prefs", "Login", $Login_Read)
	IniWrite($Config_File, "Prefs", "Password", _StringEncrypt(1, $Password_Read, "AutoIt3", 2))
EndFunc

Func _SecsToTime($iTicks, $Delim=":")
	If Number($iTicks) >= 0 Then
		Local $iHours = Int($iTicks / 3600)
		$iTicks = Mod($iTicks, 3600)
		Local $iMins = Int($iTicks / 60)
		Local $iSecs = Round(Mod($iTicks, 60))
		If StringLen($iHours) = 1 Then $iHours = "0" & $iHours
		If StringLen($iMins) = 1 Then $iMins = "0" & $iMins
		If StringLen($iSecs) = 1 Then $iSecs = "0" & $iSecs
		Return $iHours & $Delim & $iMins & $Delim & $iSecs
	EndIf
	Return SetError(1, 0, 0)
EndFunc

Func _MsgBox($MsgBoxType, $MsgBoxTitle, $MsgBoxText, $mainGUI)
	TraySetClick(0)
	Local $mRet = DllCall("user32.dll", "int", "MessageBox", "hwnd", $mainGUI, _
		"str", $MsgBoxText, "str", $MsgBoxTitle, "int", $MsgBoxType)
	TraySetClick(16)
    Return $mRet[0]
EndFunc
